darcs-2.18.2: a distributed, interactive, smart revision control system

Safe Haskell | None
Language | Haskell2010

Darcs.Repository.Resolution

Synopsis

- standardResolution :: forall (p :: Type -> Type -> Type) wO wX wY. RepoPatch p => RL (PatchInfoAnd p) wO wX -> RL (PatchInfoAnd p) wX wY -> StandardResolution (PrimOf p) wY
- rebaseResolution :: forall (p :: Type -> Type -> Type) wO wX wY. (Conflict p, PrimPatch (PrimOf p)) => RL (PatchInfoAnd p) wO wX -> RL (Named p) wX wY -> StandardResolution (PrimOf p) wY
- externalResolution :: forall (p :: Type -> Type -> Type) wX wY wZ wA. (RepoPatch p, ApplyState p ~ Tree) => DiffAlgorithm -> Tree IO -> String -> WantGuiPause -> FL (PrimOf p) wX wY -> FL (PrimOf p) wX wZ -> FL p wY wA -> IO (Sealed (FL (PrimOf p) wA))
- patchsetConflictResolutions :: forall (p :: Type -> Type -> Type) wX. RepoPatch p => PatchSet p Origin wX -> StandardResolution (PrimOf p) wX
- data StandardResolution (prim :: Type -> Type -> Type) wX = StandardResolution {
  - mangled :: Mangled prim wX
  - unmangled :: [Unravelled prim wX]
  - conflictedPaths :: [AnchoredPath]
  }
- announceConflicts :: forall (prim :: Type -> Type -> Type) wX. PrimPatch prim => String -> AllowConflicts -> StandardResolution prim wX -> IO Bool
- warnUnmangled :: forall (prim :: Type -> Type -> Type) wX. PrimPatch prim => Maybe [AnchoredPath] -> StandardResolution prim wX -> IO ()
- showUnmangled :: forall (prim :: Type -> Type -> Type) wX. PrimPatch prim => Maybe [AnchoredPath] -> [Unravelled prim wX] -> Doc
- showUnravelled :: forall (prim :: Type -> Type -> Type) wX. PrimPatch prim => Doc -> Unravelled prim wX -> Doc

# Documentation

standardResolution :: forall (p :: Type -> Type -> Type) wO wX wY. RepoPatch p => RL (PatchInfoAnd p) wO wX -> RL (PatchInfoAnd p) wX wY -> StandardResolution (PrimOf p) wY #

rebaseResolution :: forall (p :: Type -> Type -> Type) wO wX wY. (Conflict p, PrimPatch (PrimOf p)) => RL (PatchInfoAnd p) wO wX -> RL (Named p) wX wY -> StandardResolution (PrimOf p) wY #

Like `standardResolution` but it doesn't use the `instance (Named p)` because the traling list of patches may contain "fake" conflictors.

externalResolution #

Arguments

:: forall (p :: Type -> Type -> Type) wX wY wZ wA. (RepoPatch p, ApplyState p ~ Tree) |
=> DiffAlgorithm |
-> Tree IO | working tree
-> String | external merge tool command
-> WantGuiPause | tell whether we want GUI pause
-> FL (PrimOf p) wX wY | our effect
-> FL (PrimOf p) wX wZ | their effect
-> FL p wY wA | them merged
-> IO (Sealed (FL (PrimOf p) wA)) |

patchsetConflictResolutions :: forall (p :: Type -> Type -> Type) wX. RepoPatch p => PatchSet p Origin wX -> StandardResolution (PrimOf p) wX #

data StandardResolution (prim :: Type -> Type -> Type) wX #

Constructors

StandardResolution |

Fields

- mangled :: Mangled prim wX
- unmangled :: [Unravelled prim wX]
- conflictedPaths :: [AnchoredPath]

announceConflicts :: forall (prim :: Type -> Type -> Type) wX. PrimPatch prim => String -> AllowConflicts -> StandardResolution prim wX -> IO Bool #

warnUnmangled :: forall (prim :: Type -> Type -> Type) wX. PrimPatch prim => Maybe [AnchoredPath] -> StandardResolution prim wX -> IO () #

showUnmangled :: forall (prim :: Type -> Type -> Type) wX. PrimPatch prim => Maybe [AnchoredPath] -> [Unravelled prim wX] -> Doc #

showUnravelled :: forall (prim :: Type -> Type -> Type) wX. PrimPatch prim => Doc -> Unravelled prim wX -> Doc #